The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::Flute Class Reference

STK flute physical model class. More...

`#include <Flute.h>`

Inheritance diagram for stk::Flute:

List of all members.

## Public Member Functions
| Flute (StkFloat lowestFrequency)
| Class constructor, taking the lowest desired playing frequency.
| ~Flute (void)
| Class destructor.
void | clear (void)
| Reset and clear all internal state.
void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
void | setJetReflection (StkFloat coefficient)
| Set the reflection coefficient for the jet delay (-1.0 - 1.0).
void | setEndReflection (StkFloat coefficient)
| Set the reflection coefficient for the air column delay (-1.0 - 1.0).
void | setJetDelay (StkFloat aRatio)
| Set the length of the jet delay in terms of a ratio of jet delay to air column delay lengths.
void | startBlowing (StkFloat amplitude, StkFloat rate)
| Apply breath velocity to instrument with given amplitude and rate of increase.
void | stopBlowing (StkFloat rate)
| Decrease breath velocity with given rate of decrease.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

STK flute physical model class.

This class implements a simple flute physical model, as discussed by Karjalainen, Smith, Waryznyk, etc. The jet model uses a polynomial, a la Cook.

This is a digital waveguide model, making its use possibly subject to patents held by Stanford University, Yamaha, and others.

Control Change Numbers:

- Jet Delay = 2
- Noise Gain = 4
- Vibrato Frequency = 11
- Vibrato Gain = 1
- Breath Pressure = 128

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::Flute::Flute | ( | StkFloat | lowestFrequency | ) |

Class constructor, taking the lowest desired playing frequency.

An StkError will be thrown if the rawwave path is incorrectly set.

## Member Function Documentation

StkFrames & stk::Flute::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Instrmnt.

    00138 {
    00139   unsigned int nChannels = lastFrame_.channels();
    00140 #if defined(_STK_DEBUG_)
    00141   if ( channel > frames.channels() - nChannels ) {
    00142     oStream_ << "Flute::tick(): channel and StkFrames arguments are incompatible!";
    00143     handleError( StkError::FUNCTION_ARGUMENT );
    00144   }
    00145 #endif
    00146
    00147   StkFloat *samples = &frames[channel];
    00148   unsigned int j, hop = frames.channels() - nChannels;
    00149   if ( nChannels == 1 ) {
    00150     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00151       *samples++ = tick();
    00152   }
    00153   else {
    00154     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00155       *samples++ = tick();
    00156       for ( j=1; j<nChannels; j++ )
    00157         *samples++ = lastFrame_[j];
    00158     }
    00159   }
    00160
    00161   return frames;
    00162 }

The documentation for this class was generated from the following file:

- Flute.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.